library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity counter is
	port (clk, reset : in std_logic;
		P : out std_logic_vector(2 downto 0)
	);
end entity counter;

architecture arithmetic of counter is
	signal Q, NQ : unsigned (2 downto 0);
begin
	reg: process (clk) -- state register
		begin
		if (clk'event and clk = '1') then
			if (reset = '1') then
				Q <= "000";
			else
				Q <= NQ;
			end if;
		end if;
	end process;

	comb: process (Q) -- compute NQ value
	begin
		NQ <= Q + 1;		
	end process;

	P <= std_logic_vector(Q);
end arithmetic;
