library IEEE;
use IEEE.std_logic_1164.all;

entity counter is
        port (clk, reset : in std_logic;
                P : out std_logic_vector(2 downto 0)
        );
end entity counter;

architecture fsm of counter is
	signal Q, NQ : std_logic_vector(2 downto 0);
begin 
	reg: process (clk) -- state register
	begin
		if (clk'event and clk = '1') then  
			if (reset = '1') then 
				Q <= "000";
			else 
				Q <= NQ ;
			end if;
		end if;
	end process;

	comb: process (Q) -- compute NQ value
	begin
		case Q is
			when "000" =>  -- S0
				NQ <= "001"; 
			when "001" =>  -- S1
				NQ <= "010"; 
			when "010" =>  -- S2
				NQ <= "011"; 
			when "011" =>  -- S3
				NQ <= "100"; 
			when "100" =>  -- S4
				NQ <= "101"; 
			when "101" =>  -- S5
				NQ <= "110"; 
			when "110" =>  -- S6
				NQ <= "111"; 
			when "111" =>  -- S7
				NQ <= "000"; 
			when others => -- to catch "UUU" etc.
				NQ <= "000"; 
		end case;
	end process;
	
	P <= Q;
end fsm;
