library IEEE;
use IEEE.std_logic_1164.ALL;

entity seg7dec is
	port (A, B, C, D : in std_logic;
		  C0, C1, C2, C3, C4, C5, C6 : out std_logic
	);
end entity seg7dec;

architecture behaviour of seg7dec is
	signal I : std_logic_vector(0 to 3);
	signal O : std_logic_vector(0 to 6);
begin 
	I <= (A, B, C, D);
	
	comb: process (I)
	begin
		case I is
	  		when "0011" => O <= "1111110";  -- 0
			when "0100" => O <= "0110000";  -- 1
			when "0101" => O <= "1101101";  -- 2
			when "0110" => O <= "1111001";  -- 3
			when "0111" => O <= "0110011";  -- 4
			when "1000" => O <= "1011011";  -- 5
			when "1001" => O <= "1011111";  -- 6
			when "1010" => O <= "1110000";  -- 7
			when "1011" => O <= "1111111";  -- 8
			when "1100" => O <= "1110011";  -- 9
			when others => O <= "-------";
		end case;
	end process;
	
	(C0, C1, C2, C3, C4, C5, C6) <= O;
end behaviour;